//###########################################################################//
//
//Project :   Edit3D  v 0.96 Beta  for Ti 89
//
//Author:  David Coz      
//
//Mail  :  coz.hubert@infonie.fr
//
// Main Program
//
//Created 10/05/2002; 00:21:07
//
//############################################################################//





#define MIN_AMS 100

#define USE_TI89              // Produce .89z File

#define OPTIMIZE_ROM_CALLS     // Use ROM Call Optimization
#define STRICT_POINTERS

#define NO_EXIT_SUPPORT

#define SET_FILE_IN_USE_BIT 


          // Save/Restore LCD Contents

#include "functions_sw.h"
#include "3D_display_sw.h"
#include "sprite_sw.h"
#include "title_sw.h"
#include "options_sw.h"
 
#include <tigcclib.h>         // Include All Header Files
        // Include All Header Files
//#include "clock.h"

#define PIXOFFSET(x,y)  ((y<<5)-(y<<1)+(x>>3))
#define PIXADDR(p,x,y)  (((unsigned char*)(p))+PIXOFFSET(x,y))
#define PIXMASK(x)      ((unsigned char)(0x80 >> ((x)&7)))

#define GETPIX(p,x,y)   (!(!(*PIXADDR(p,x,y) & PIXMASK(x))))
#define SETPIX(p,x,y)   (*PIXADDR(p,x,y) |=  PIXMASK(x))
#define CLRPIX(p,x,y)   (*PIXADDR(p,x,y) &= ~PIXMASK(x))
#define XORPIX(p,x,y)   (*PIXADDR(p,x,y) ^=  PIXMASK(x))



#define ABS(a)  (((a)<0) ? -(a): (a))
#define SGN(a)  (((a)<0) ? -1 : 1)
#define ARCH   1

#define ASM_EXCHANGE(val1,val2) asm volatile ("exg %0,%1" : "=d" (val1),"=d" (val2) : "0" (val1),"1" (val2) : "memory","cc")


int work_time;








//Global Declaration of Arrays used in the whole program
short (*nbpoint) = NULL;//nb of points for an object
short (*modeh) = NULL;//1 for flat object,2 for solid object
char (*mm)[6] = NULL;//points coord.
char (*color) = NULL;//color of each object
//char (*text_name)[10] = NULL;
TEXT_SAVE (*text_name)=NULL;

int (*Ligne)[2] ;//lines for the wire-frame display

int (*Lin)[3] ;//lines for the wire-frame display
//int (*mptca)[4] = NULL;//points coord used in the display routine 
void *Vscreen = NULL; //Virtual Screens
//void *Vscreen1 = NULL; 
//unsigned char (*Z_BUFFER)[160]=NULL;// Z_Buffer Array

 char foldfile[10];
short vx=1,vy=2,vz=3,pile=1,obj=0,points=0,ligne=0,faces=0,vue=1,
triangle=0;
int disto=100,code;
char grille=1,perspective=1,save_option=0,default_z_buf=0,center_defined=0,center_input;
char  name[8]={},auto_archiv=0;
short collision[10];
short Canon[2];


/*
function used for debuging
void test(void)
{
FontSetSys(F_4x6);
int i,j;
	ClrScr();
	printf_xy(25,5,"%d:%d",obj,pile);
		
	for (i=0;i<obj;i++)
	{
		printf_xy(25,25+i*10,"%d:%d",modeh[i],nbpoint[i+1]-nbpoint[i]);
		}
		ngetchx();
	ClrScr();
	
			for (i=0;i<pile-1;i++)
			for (j=0;j<6;j++)
		printf_xy(j*10,i*6,"%d",mm[i][j]);
			
			ngetchx();
	FontSetSys(F_6x8);

}
*/

// (Un)Archive the current file
void archive(int un)
{
if (!auto_archiv && un<2)
return;
//HeapCompress (); 


un &=1;
char fi[30],*pfi=fi;

strcpy(fi,foldfile);
pfi+=strlen(foldfile);
*pfi='\\';  
*(++pfi)='\0'; 
strcat(fi,name);

/*
TRY
if (un)
cmd_archive(SYMSTR(fi));
else
cmd_unarchiv(SYMSTR(fi));
ONERR
ENDTRY
*/


HSYM hsym = SymFind (SYMSTR(fi));

/*
SYM_ENTRY *SymPtr = DerefSym (SymFind (fi));
DlgMessage("file",fi,0,0);


if (SymPtr==NULL) 
{
//DlgMessage ("ERROR","Do not Exist...", BT_OK, BT_NONE);
return;
}
*/

//FILE *fp;
//fp = fopen(name,"rb"); 
//if (fp!=NULL) 

//fclose(fp);
//TRY

	if (un==1)//&&SymPtr->flags.bits.archived ==0) //archive
	{
  	 (EM_moveSymToExtMem(NULL,hsym));
  	  //DlgMessage ("ERROR","...", BT_OK, BT_NONE);
	}
	if (un==0)//&&SymPtr->flags.bits.archived ==1) //unarchive
	{
	  (EM_moveSymFromExtMem(NULL,hsym));
	     //DlgMessage ("ERROR","...", BT_OK, BT_NONE);
	}

//ONERR
//ENDTRY
}



//Refresh the whole object in the editor
void redes(void)
{
int i,j;
ClrScr();
if (grille)
{
	for (i=2;i<118;i+=5)
 for (j=18;j<94;j+=5)
 DrawPix (i, j,A_NORMAL); 
DrawLine(1,17,118,17,A_NORMAL);
DrawLine(1,17,1,94,A_NORMAL);
DrawLine(1,94,118,94,A_NORMAL);
DrawLine(118,94,118,17,A_NORMAL);
}
//	if (obj==0) return;
	
	i=0;
	for (i=0;i<ligne;i++)
	DrawLine(2+Lin[Ligne[i][0]-1][vx-1],18+Lin[Ligne[i][0]-1][vy-1],
	2+Lin[Ligne[i][1]-1][vx-1],18+Lin[Ligne[i][1]-1][vy-1],A_NORMAL);
 
 memcpy(Vscreen,LCD_MEM, 3840);
 

}


//function that stores the coord clockwise for the backface-culling
void cross(int pil,int n,int ordre,int dec)
{
	int x1,y1,z1,x2,y2,z2,tab[3],i,j;
	int buf[50][3];
			x1=mm[pil][0+dec]-mm[pil+1][0+dec];
    	x2=mm[pil+2][0+dec]-mm[pil+1][0+dec];
    	
    	y1=mm[pil][1+dec]-mm[pil+1][1+dec];
    	y2=mm[pil+2][1+dec]-mm[pil+1][1+dec];
    	
    	z1=mm[pil][2+dec]-mm[pil+1][2+dec];
    	z2=mm[pil+2][2+dec]-mm[pil+1][2+dec];
	
	tab[0]=y1*z2-y2*z1;
	tab[1]=z1*x2-z2*x1;
	tab[2]=x1*y2-x2*y1;
	
	
	if (tab[vz-1]*ordre>0)
	{
		
		
		for (i=0;i<n;i++)
		for (j=0;j<3;j++)
		buf[i][j]=mm[i+pil][j+dec];

			
			for (i=0;i<n;i++)
			for (j=0;j<3;j++)
		{
		
		mm[i+pil][j+dec]=buf[n-i-1][j];
		}
		
		}
		
}


void add_texture(int num_obj,int num_face,int dec)
{
faces+=num_face;

text_name=realloc(text_name, (faces)*sizeof(*text_name));

int i/*j*/,offset=0;

for (i=0;i<num_obj;i++)
offset+=(nbpoint[i+1]-nbpoint[i])*(ABS(modeh[i])-1)+2;



if (num_obj!=obj-1)
{
for (i=faces-1;i>=offset+num_face+dec;i--)
{
strcpy(text_name[i].name,text_name[i-num_face].name);
text_name[i].offset=text_name[i-num_face].offset;
}
}

for (i=offset+dec;i<offset+dec+num_face;i++)
{
strcpy(text_name[i].name,"0");
text_name[i].offset=0;
}



}


//Draw lines in the editor
void lign(int yy,int xx,int e,int d,int mode)
{
int quit=0,k,p=0,pi=pile;
	memcpy( Vscreen,LCD_MEM, 3840);
		while (quit==0)
	{
		DrawLine (xx+2,yy+18,xx+2+d,18+yy+e, A_NORMAL);
     quit=touche(&d,&e,xx,yy);
      memcpy(LCD_MEM, Vscreen, 3840);
     printf_xy(138,61+vx*9,"%d  ",xx+d);
	printf_xy(138,61+vy*9,"%d  ",yy+e);
  
  if (pile-pi>19&&quit==13)
  quit=0;
  
   			 if (quit==13) 
    				{
        			
    				if (p==0)	pile+=2;
    				if (p!=0) pile++;
    			
    			 p++;   		 
    			 mm= realloc(mm, (pile-1)*sizeof(*mm));
 
    						for (k=0;k<2;k++)
    						{
    		  				mm[pile-3][vx+3*k-1]=xx;
    							mm[pile-3][vy+3*k-1]=yy;
    							mm[pile-3][vz+3*k-1]=0;
    		
    							mm[pile-2][vx+3*k-1]=xx+d;
    							mm[pile-2][vy+3*k-1]=yy+e;
    							mm[pile-2][vz+3*k-1]=0;
    						}
    		
    		
    			DrawLine (xx+2,yy+18,xx+2+d,18+yy+e, A_NORMAL);  
   				memcpy( Vscreen,LCD_MEM, 3840);	
    				xx+=d;
    				yy+=e;
    				d=5;
     					e=5;
      					 if (xx>110) d=-5;
    		  					 if (yy>70) e=-5;
    									
   quit=0;
   							} 	
             
						}
						if (pi==pile) return;
	
						obj++;
  modeh= realloc(modeh, (obj)*sizeof(*modeh));
  nbpoint= realloc(nbpoint, (obj+1)*sizeof(*nbpoint));
  modeh[obj-1]=mode;
  	color=realloc(color,obj*sizeof(*color));
  	color[obj-1]=0;
 
 
  cross(pi-1,pile-pi,1,0);
  cross(pi-1, pile-pi,1,3);
  
  
  
  nbpoint[obj]=pile;
  if (mode==1)
  DrawLine (mm[nbpoint[obj-1]-1][vx-1]+2,mm[nbpoint[obj-1]-1][vy-1]+18,
  mm[nbpoint[obj]-2][vx-1]+2,mm[nbpoint[obj]-2][vy-1]+18, A_NORMAL);  
add_texture(obj-1,2,0);

memcpy( Vscreen,LCD_MEM, 3840);
}



	
	
//Draw Rectangle in the Editor	
void rect(int yy,int xx,int e,int d)
{
int quit=0,k;
	memcpy( Vscreen,LCD_MEM, 3840);
		while (quit==0&&quit!=13)
	{
		DrawClipRect (MakeWinRect (xx+2,yy+18,xx+2+d,18+yy+e),&(SCR_RECT){{0, 0, 159, 99}}, A_NORMAL);
     quit=touche(&d,&e,xx,yy);
      memcpy(LCD_MEM, Vscreen, 3840);
     printf_xy(138,61+vx*9,"%d  ",xx+d);
	printf_xy(138,61+vy*9,"%d  ",yy+e);
  
    }
    if (quit==13) 
    {
    	obj++;
    	modeh= realloc(modeh, (obj)*sizeof(*modeh));
    	modeh[obj-1]=1;
    	
    	nbpoint= realloc(nbpoint, (obj+1)*sizeof(*nbpoint));
    	
    	color=realloc(color,obj*sizeof(*color));
  	color[obj-1]=0;
    	nbpoint[obj]=pile+4;
    	
    	
    	    	
    		mm= realloc(mm, (nbpoint[obj]-1)*sizeof(*mm));
    
    		
    		
    	for (k=0;k<2;k++)
    	{
    		mm[pile-1][vx+3*k-1]=xx;
    		mm[pile-1][vy+3*k-1]=yy;
    		mm[pile-1][vz+3*k-1]=0;
    		
    		mm[pile][vx+3*k-1]=xx+d;
    		mm[pile][vy+3*k-1]=yy;
    		mm[pile][vz+3*k-1]=0;
    		
    		mm[pile+1][vx+3*k-1]=xx+d;
    		mm[pile+1][vy+3*k-1]=yy+e;
    		mm[pile+1][vz+3*k-1]=0;
    		
    		mm[pile+2][vx+3*k-1]=xx;
    		mm[pile+2][vy+3*k-1]=yy+e;
    	mm[pile+2][vz+3*k-1]=0;
    	}
    	pile+=4;
    
    cross(pile-5,4,1,0);
   
    cross(pile-5,4,1,3);
      
      add_texture(obj-1,2,0);
      
    	DrawClipRect (MakeWinRect (xx+2,yy+18,xx+2+d,18+yy+e),&(SCR_RECT){{0, 0, 159, 99}}, A_NORMAL);
    
    		memcpy( Vscreen,LCD_MEM, 3840);
   } 	
}



//Draw Ellipse in the Editor
void ell(int yy,int xx,int e,int d)
{
int quit=0,k,i,j,m,n;
	memcpy( Vscreen,LCD_MEM, 3840);
		while (quit==0&&quit!=13)
	{
		DrawClipEllipse(xx+2,yy+18,d,e,&(SCR_RECT){{0, 0, 159, 99}}, A_NORMAL);
     quit=touche2(&d,&e,xx,yy);
      memcpy(LCD_MEM, Vscreen, 3840);
     printf_xy(138,61+vx*9,"%d  ",xx+d);
	printf_xy(138,61+vy*9,"%d  ",yy+e);
  
    }
    if (quit==13) 
    {
    	obj++;
    	modeh= realloc(modeh, (obj)*sizeof(*modeh));
    	modeh[obj-1]=1;
    	
    	nbpoint= realloc(nbpoint, (obj+1)*sizeof(*nbpoint));
    	nbpoint[obj]=pile+12;
    	
    	
    	
    	color=realloc(color,obj*sizeof(*color));
  	color[obj-1]=4;
   
    		mm= realloc(mm, (nbpoint[obj]-1)*sizeof(*mm));
    		i=((d*111)>>7);
    		if ((((10*d*111)>>7)-10*i)>4) i++;// 111 = 128*cos(30 Degree)
    		
    		m=d>>1;
    		
    		j=e>>1;
    		n=((e*111)>>7);
    		if ( ( ((10*e*111)>>7)-10*n  )>4) n++;
    		
    	for (k=0;k<2;k++)
    	{
    		mm[pile-1][vx+3*k-1]=xx+d;
    		mm[pile-1][vy+3*k-1]=yy;
    		mm[pile-1][vz+3*k-1]=0;
    		
    		mm[pile][vx+3*k-1]=xx+i;
    		mm[pile][vy+3*k-1]=yy+j;
    		mm[pile][vz+3*k-1]=0;
    		
    		mm[pile+1][vx+3*k-1]=xx+m;
    		mm[pile+1][vy+3*k-1]=yy+n;
    		mm[pile+1][vz+3*k-1]=0;
    		
    		mm[pile+2][vx+3*k-1]=xx;
    		mm[pile+2][vy+3*k-1]=yy+e;
    	mm[pile+2][vz+3*k-1]=0;
    	
    	mm[pile+3][vx+3*k-1]=xx-m;
    		mm[pile+3][vy+3*k-1]=yy+n;
    		mm[pile+3][vz+3*k-1]=0;
    		
    		mm[pile+4][vx+3*k-1]=xx-i;
    		mm[pile+4][vy+3*k-1]=yy+j;
    		mm[pile+4][vz+3*k-1]=0;
    		
    		mm[pile+5][vx+3*k-1]=xx-d;
    		mm[pile+5][vy+3*k-1]=yy;
    		mm[pile+5][vz+3*k-1]=0;
    	
    	mm[pile+6][vx+3*k-1]=xx-i;
    		mm[pile+6][vy+3*k-1]=yy-j;
    		mm[pile+6][vz+3*k-1]=0;
    		
    		mm[pile+7][vx+3*k-1]=xx-m;
    		mm[pile+7][vy+3*k-1]=yy-n;
    		mm[pile+7][vz+3*k-1]=0;
    		
    		mm[pile+8][vx+3*k-1]=xx;
    		mm[pile+8][vy+3*k-1]=yy-e;
    		mm[pile+8][vz+3*k-1]=0;
    		
    		mm[pile+9][vx+3*k-1]=xx+m;
    		mm[pile+9][vy+3*k-1]=yy-n;
    		mm[pile+9][vz+3*k-1]=0;
    		
    			mm[pile+10][vx+3*k-1]=xx+i;
    		mm[pile+10][vy+3*k-1]=yy-j;
    		mm[pile+10][vz+3*k-1]=0;
    	
    	 	}
    	pile+=12;
    
    cross(pile-13,12,1,0);
    
    cross(pile-13,12,1,3);
      
      add_texture(obj-1,2,0);
      
    	DrawClipEllipse (xx+2,yy+18,d,e,&(SCR_RECT){{0, 0, 159, 99}}, A_NORMAL);
    
    		memcpy( Vscreen,LCD_MEM, 3840);
   } 	
}






//Cursor Display 
int curseur(int *x,int *y,int *e,int *d)
{
static char curseur[8]={0x20,0x20,0xD8,0x20,0x20,0x00,0x00,0x00};
int quit=0,x1=*x,y1=*y;
while (quit==0&&quit!=13)
{
Sprite8(*x,16+*y,5,curseur,LCD_MEM,SPRT_XOR); 
	quit=touche(x,y,0,0);
	printf_xy(138,61+vx*9,"%d  ",*x);
	printf_xy(138,61+vy*9,"%d  ",*y);
Sprite8(x1,16+y1,5,curseur,LCD_MEM,SPRT_XOR); 

x1=*x;
y1=*y;
}
*d=5;
*e=5;
if (*x>110) *d=-5;
if (*y>70) *e=-5;
return quit;
}







//Function for selecting an object
int choix(void)
{
static char curseur[8]={0x70,0xF8,0xD8,0xF8,0x70,0x00,0x00,0x00};
	int i,l=0,s;
	while(1)
	{
		memcpy( Vscreen,LCD_MEM, 3840);
		FontSetSys(F_4x6);
	printf_xy(119,40,"Object :%d  ",l+1);
		FontSetSys(F_6x8);
	for(i=nbpoint[l];i<nbpoint[l+1];i++)
	
	{
Sprite8(mm[i-1][vx-1],16+mm[i-1][vy-1],5,curseur,LCD_MEM,SPRT_OR); 
Sprite8(mm[i-1][vx+2],16+mm[i-1][vy+2],5,curseur,LCD_MEM,SPRT_OR); 
}

 	 	 s=0;
 	 	 while (s==0)
 	 	 s=ngetchx();
 	 	 
 	 	 if (s==344&&l<obj-1) l++;
 	 	 if (s==338&&l>0) l--;
	 	 
 	 	 if (s==264) return 264;
 	 	 if (s==13) return l;
 	 		memcpy( LCD_MEM,Vscreen, 3840); 	 
 	 	}	 
 	
}

void flip()
{
int i,j;
for (i=0;i<nbpoint[obj]-1;i++)
for (j=0;j<2;j++)
mm[i][vx-1+j*3]=115-mm[i][vx-1+j*3];
compile();
redes();
}



//Translate function
void translater(int mode)
{
int l=0,j,i,t[3],start=0,end=pile-1,f=0;

	if (obj==0) return;
if (mode==1) {
l=choix();
if (l==264) return;
}	
	HANDLE handle;
while(1){

for (i=0;i<3;i++)
{
char res[4]={"000\0"};
char *buf=res;
	handle = DialogNewSimple (140, 55);
DialogAddTitle (handle, "TRANSLATION", BT_OK, BT_NONE);
DialogAddRequest (handle, 3, 30,(i==0 ? "On X Axis":(i==1 ?"On Y Axis":"On Z Axis")), 0, 3, 8);
DialogDo (handle, CENTER, CENTER, buf, NULL);
HeapUnlock (handle);
HeapFree (handle);	
t[i]=atoi(buf);
}

if (mode==1)
{
	start=nbpoint[l]-1;
end=nbpoint[l+1]-1;
}
f=0;
for (i=start;i<end;i++)
for (j=0;j<3;j++)
{
	if (mm[i][j]+t[j]>115||mm[i][j]+t[j]<0
		||mm[i][j+3]+t[j]>115||mm[i][j+3]+t[j]<0)
f=1;
}

if (f==0) break; 

 DlgMessage ("ERROR","Wrong Translation Vector", BT_OK, BT_NONE);

}
for (i=start;i<end;i++)
for (j=0;j<3;j++)
{
	mm[i][j]+=t[j];
	mm[i][j+3]+=t[j];
}


compile();
redes();
}


//Choose the color of an object
void colo(int col)
{
	int i;
	if (obj==0) return;
i=choix();
if (i==264) return;
color[i]=4*((color[i])>>2)+2*((color[i])>>1)+col;
}

void bord(int bor)
{
	int i;
	if (obj==0) return;
i=choix();
if (i==264) return;

bor+=color[i]&1;
bor+=(color[i]&4)*4;
color[i]=bor;
}

//Shorten or Lengthen an object
void zoom(int mode)
{
int l=0,j,i,zo[3],start=0,end=pile-1,f=0;
char zoom_text[3][30]={"On X Axis","On Y Axis","On Z Axis"};
	if (obj==0) return;
if (mode==1) {
l=choix();
if (l==264) return;
}	
	HANDLE handle;
while(1){


for (i=0;i<3;i++)
{
char res[4]={"100\0"};
char *buf=res;
	handle = DialogNewSimple (140, 55);
DialogAddTitle (handle, "Zoom", BT_OK, BT_NONE);
DialogAddRequest (handle, 3, 20,zoom_text[i], 0, 3, 8);
DialogAddText (handle, 3, 35, "(%) Multiply by 100.");

DialogDo (handle, CENTER, CENTER, buf, NULL);
HeapUnlock (handle);
HeapFree (handle);	
zo[i]=atoi(buf);
}


if (mode==1)
{
	start=nbpoint[l]-1;
end=nbpoint[l+1]-1;
}
f=0;
for (i=start;i<end;i++)
for (j=0;j<3;j++)
{
	if ((mm[i][j]*zo[j]/100)>115||(mm[i][j]*zo[j]/100)<0
		||(mm[i][j+3]*zo[j]/100)>115||(mm[i][j+3]*zo[j]/100)<0)
f=1;
}

if (f==0) break; 

 DlgMessage ("ERROR","Beyond the Limits", BT_OK, BT_NONE);

}
for (i=start;i<end;i++)
for (j=0;j<3;j++)
{

	mm[i][j]=(int)(zo[j]*mm[i][j])/100;
	mm[i][j+3]=(int)(zo[j]*mm[i][j+3])/100;
}


compile();
redes();
}

//Rotate an object around a point
void rotate(int mode)
{

long int (*rmat)[4]=NULL;
//char cta[360]={64,64,64,64,64,64,64,64,63,63,63,63,63,62,62,62,62,61,61,61,60,60,59,59,58,58,58,57,57,56,55,55,54,54,53,52,52,51,50,50,49,48,48,47,46,45,44,44,43,42,41,40,39,39,38,37,36,35,34,33,32,31,30,29,28,27,26,25,24,23,22,21,20,19,18,17,15,14,13,12,11,10,9,8,7,6,4,3,2,1,0,-1,-2,-3,-4,-6,-7,-8,-9,-10,-11,-12,-13,-14,-15,-17,-18,-19,-20,-21,-22,-23,-24,-25,-26,-27,-28,-29,-30,-31,-32,-33,-34,-35,-36,-37,-38,-39,-39,-40,-41,-42,-43,-44,-44,-45,-46,-47,-48,-48,-49,-50,-50,-51,-52,-52,-53,-54,-54,-55,-55,-56,-57,-57,-58,-58,-58,-59,-59,-60,-60,-61,-61,-61,-62,-62,-62,-62,-63,-63,-63,-63,-63,-64,-64,-64,-64,-64,-64,-64,-64,-64,-64,-64,-64,-64,-64,-64,-63,-63,-63,-63,-63,-62,-62,-62,-62,-61,-61,-61,-60,-60,-59,-59,-58,-58,-58,-57,-57,-56,-55,-55,-54,-54,-53,-52,-52,-51,-50,-50,-49,-48,-48,-47,-46,-45,-44,-44,-43,-42,-41,-40,-39,-39,-38,-37,-36,-35,-34,-33,-32,-31,-30,-29,-28,-27,-26,-25,-24,-23,-22,-21,-20,-19,-18,-17,-15,-14,-13,-12,-11,-10,-9,-8,-7,-6,-4,-3,-2,-1,0,1,2,3,4,6,7,8,9,10,11,12,13,14,15,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,39,40,41,42,43,44,44,45,46,47,48,48,49,50,50,51,52,52,53,54,54,55,55,56,57,57,58,58,58,59,59,60,60,61,61,61,62,62,62,62,63,63,63,63,63,64,64,64,64,64,64,64};
//char sta[360]={0,1,2,3,4,6,7,8,9,10,11,12,13,14,15,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,39,40,41,42,43,44,44,45,46,47,48,48,49,50,50,51,52,52,53,54,54,55,55,56,57,57,58,58,58,59,59,60,60,61,61,61,62,62,62,62,63,63,63,63,63,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,63,63,63,63,63,62,62,62,62,61,61,61,60,60,59,59,58,58,58,57,57,56,55,55,54,54,53,52,52,51,50,50,49,48,48,47,46,45,44,44,43,42,41,40,39,39,38,37,36,35,34,33,32,31,30,29,28,27,26,25,24,23,22,21,20,19,18,17,15,14,13,12,11,10,9,8,7,6,4,3,2,1,0,-1,-2,-3,-4,-6,-7,-8,-9,-10,-11,-12,-13,-14,-15,-17,-18,-19,-20,-21,-22,-23,-24,-25,-26,-27,-28,-29,-30,-31,-32,-33,-34,-35,-36,-37,-38,-39,-39,-40,-41,-42,-43,-44,-44,-45,-46,-47,-48,-48,-49,-50,-50,-51,-52,-52,-53,-54,-54,-55,-55,-56,-57,-57,-58,-58,-58,-59,-59,-60,-60,-61,-61,-61,-62,-62,-62,-62,-63,-63,-63,-63,-63,-64,-64,-64,-64,-64,-64,-64,-64,-64,-64,-64,-64,-64,-64,-64,-63,-63,-63,-63,-63,-62,-62,-62,-62,-61,-61,-61,-60,-60,-59,-59,-58,-58,-58,-57,-57,-56,-55,-55,-54,-54,-53,-52,-52,-51,-50,-50,-49,-48,-48,-47,-46,-45,-44,-44,-43,-42,-41,-40,-39,-39,-38,-37,-36,-35,-34,-33,-32,-31,-30,-29,-28,-27,-26,-25,-24,-23,-22,-21,-20,-19,-18,-17,-15,-14,-13,-12,-11,-10,-9,-8,-7,-6,-4,-3,-2,-1};
int l=0,j,i,start=0,end=pile-1,f=0,u=20,v=20,rot,k;
unsigned char ang,ro;
long int xc=0,yc=0,norme;
	if (obj==0) return;
		if (mode==1) {
			l=choix();
			if (l==264) return;
			}	
	HANDLE handle;
while(1){
char res[4]={"000\0"};
char *buf=res;
	handle = DialogNewSimple (140, 55);
DialogAddTitle (handle, "Rotation", BT_OK, BT_NONE);
DialogAddRequest (handle, 3, 20,"Angle(Degree)", 0, 3, 8);
DialogAddText (handle, 3, 35, "Then Place The Rotation Center");

if ((DialogDo (handle, CENTER, CENTER, buf, NULL))==KEY_ESC)
{
HeapUnlock (handle);
HeapFree (handle);	
return;
}
HeapUnlock (handle);
HeapFree (handle);	

rot=-atoi(buf);
rot=(rot*32)/45;
rot=(unsigned char) rot;
 
if (mode==1)
{
	start=nbpoint[l]-1;
end=nbpoint[l+1]-1;
}
xc=0;
yc=0;
for (i=start;i<end;i++)
{
	xc+=mm[i][vx-1];
	yc+=mm[i][vy-1];
}
u=xc/(5*(end-start));
u=5*u;
v=yc/(5*(end-start));
v=5*v;


if (curseur(&u,&v,&i,&j)==1) return;

rmat=calloc (end-start+1, sizeof (*rmat));
f=0;
for (i=start;i<end;i++)
for (j=0;j<2;j++)
{
j*=3;
k=j*2;
norme=sqrt(4*((mm[i][vx-1+j]-u)*(mm[i][vx-1+j]-u)+(mm[i][vy-1+j]-v)*(mm[i][vy-1+j]-v)));
ang=(128/PI)*atan2(mm[i][vy-1+j]-v,mm[i][vx-1+j]-u);


ro=ang+rot;

rmat[i][k]=((norme*cos255[ro])>>8)+u;
rmat[i][k+1]=(((norme*sin255[ro])>>8)+v);

	if (rmat[i][k]>115||
			rmat[i][k]<0||
			rmat[i][k+1]<0||
			rmat[i][k+1]>115)
f=1;


}
if (f==0) break; 
 DlgMessage ("ERROR","Beyond the Limits", BT_OK, BT_NONE);
free(rmat);
}
for (i=start;i<end;i++)
for (j=0;j<2;j++)
{j*=3;
k=j*2;

mm[i][vx-1+j]=rmat[i][k];
mm[i][vy-1+j]=rmat[i][k+1];


}

free(rmat);

compile();
redes();
}


void mod_center()
{
HANDLE handle;
int i,old[3],work[3],err=0;
char buf[50];
char *pbuf=buf;
char buf2[50];

for (i=0;i<2;i++)
old[i]=Lin[points][i];

while(1)
{
strcpy(buf,IntToStr(Lin[points][0]));
strcat(buf, IntToStr(Lin[points][1]));
strcat(buf, IntToStr(Lin[points][2]));
pbuf+=4;
*pbuf='\0';
pbuf+=4;
*pbuf='\0';
pbuf-=8;
if (err) DlgMessage ("ERROR","Wrong Input", BT_OK, BT_NONE);
 handle = DialogNewSimple (130, 80);
DialogAddTitle (handle, "Modify Center Coordinates...", BT_OK, BT_CANCEL);

DialogAddText (handle, 20,12,"Option 'Center' must be set");
DialogAddText (handle, 20,21,"to 'User' to take effect...");

DialogAddRequest (handle, 15, 33, "X ", 1, 3, 8);
DialogAddRequest (handle, 15, 44, "Y ",5, 3, 8);
DialogAddRequest (handle, 15, 55, "Z ", 9, 3, 8);
if (DialogDo (handle, CENTER, CENTER,buf, NULL) == KEY_ESC)
{
for (i=0;i<2;i++)
Lin[points][i]=old[i];

	HeapUnlock (handle);
	HeapFree (handle);
return;
}
HeapUnlock (handle);
	HeapFree (handle);	

strncpy(buf2,buf,4);
work[0]=atoi(buf2);
pbuf+=5;
strncpy(buf2,pbuf,4);
work[1]=atoi(buf2);
pbuf+=4;
strncpy(buf2,pbuf,4);
work[2]=atoi(buf2);
pbuf-=9;
err=1;
if (work[0]>-1&&work[0]<116&&work[1]>-1&&work[1]<116&&work[2]>-1 && work[2]<116) break;
}
center_input=1;
for (i=0;i<2;i++)
Lin[points][i]=work[i];

}


//Modify the Coordinates...
void mod_coord()
{
HANDLE handle;
int l=choix(),i,j,work[3],k,err;
if (l==264) return;
int n=nbpoint[l+1]-nbpoint[l];
char buf[50];
char *pbuf=buf;
char buf2[50],cur_point[50];
char (*temp)[6];
temp = calloc(n,sizeof(*temp));

for (i=nbpoint[l]-1;i<nbpoint[l+1]-1;i++)
for (j=0;j<6;j++)
temp[i-nbpoint[l]+1][j]=mm[i][j];

for (j=0;j<modeh[l];j++)
for (i=nbpoint[l]-1;i<nbpoint[l+1]-1;i++)
{
sprintf(cur_point,"Point %d / %d ...",j*n+i-nbpoint[l]+1,n*modeh[l]);
err=0;
while(1)
{
strcpy(buf,IntToStr(mm[i][3*j]));
strcat(buf, IntToStr(mm[i][3*j+1]));
strcat(buf, IntToStr(mm[i][3*j+2]));
pbuf+=4;
*pbuf='\0';
pbuf+=4;
*pbuf='\0';
pbuf-=8;
if (err) DlgMessage ("ERROR","Wrong Input", BT_OK, BT_NONE);
 handle = DialogNewSimple (130, 70);
DialogAddTitle (handle, "Modify Coordinates...", BT_OK, BT_CANCEL);

DialogAddText (handle, 20,13,cur_point);
DialogAddRequest (handle, 15, 26, "X ", 1, 3, 8);
DialogAddRequest (handle, 15, 37, "Y ",5, 3, 8);
DialogAddRequest (handle, 15, 48, "Z ", 9, 3, 8);
if (DialogDo (handle, CENTER, CENTER,buf, NULL) == KEY_ESC)
{
for (i=nbpoint[l]-1;i<nbpoint[l+1]-1;i++)
for (j=0;j<6;j++)
mm[i][j]=temp[i-nbpoint[l]+1][j];

free(temp);

	HeapUnlock (handle);
	HeapFree (handle);
return;
}
HeapUnlock (handle);
	HeapFree (handle);	

strncpy(buf2,buf,4);
work[0]=atoi(buf2);
pbuf+=5;
strncpy(buf2,pbuf,4);
work[1]=atoi(buf2);
pbuf+=4;
strncpy(buf2,pbuf,4);
work[2]=atoi(buf2);
pbuf-=9;
err=1;
if (work[0]>-1&&work[0]<116&&work[1]>-1&&work[1]<116&&work[2]>-1 && work[2]<116) break;
}
for (k=0;k<3;k++)
mm[i][k+3*j]=work[k];

if (modeh[l]!=2)
{
for (k=0;k<3;k++)
mm[i][k+3]=work[k];
}

}
free(temp);
center_input=1;
compile();
redes();
	
}



//Define the depth of an object
void profondeur(void)
{
int l=choix(),i,was_2=0;
if (l==264) return;
short z,zz,err=0,t;
char buf[50];
char *pbuf=buf;
char buf2[50];


HANDLE handle ;
while (1){
strcpy(buf,IntToStr(mm[nbpoint[l]-1][vz+2]));
strcat(buf,IntToStr(mm[nbpoint[l]-1][vz-1]));
pbuf+=4;
*pbuf='\0';
pbuf-=4;
 handle = DialogNewSimple (140, 55);
DialogAddTitle (handle, "DEPTH", BT_OK, BT_NONE);
if (err) DlgMessage ("ERROR","Wrong Input", BT_OK, BT_NONE);

DialogAddRequest (handle, 3, 18, "Depth Min`", 1, 3, 8);
DialogAddRequest (handle, 3, 32, "Depth Max`", 5, 3, 8);
DialogDo (handle, CENTER, CENTER, buf, NULL);
HeapUnlock (handle);
	HeapFree (handle);	

strncpy(buf2,buf,4);
z=atoi(buf2);
pbuf+=5;
strncpy(buf2,pbuf,4);
zz=atoi(buf2);
pbuf-=5;

err=1;
if (z>-1&&z<116&&zz>-1&&zz<116) break;
}

if (zz<z) {
t=zz;
zz=z;
z=t;	
}
for (i=nbpoint[l];i<nbpoint[l+1];i++)
{
	mm[i-1][vz+2]=z;
	mm[i-1][vz-1]=zz;

		}
was_2=modeh[l];
			modeh[l]=SGN(modeh[l]);
		if (mm[i-2][vz-1]!=mm[i-2][vz+2])
	modeh[l]*=2;

if (was_2==1)
		  add_texture(l,nbpoint[l+1]-nbpoint[l],2);

compile();
}



//Move a shape into a cone : square->pyramid  , circle->cone...
void cone(void)
{
int l=choix(),i,j,dec2,d1,d2,was_2;
char buf[50];
char *pbuf=buf;
char buf2[50];
if (l==264) return;
if (nbpoint[l+1]-nbpoint[l]<3)
{
DlgMessage ("ERROR","Object with more than 2 points!", BT_OK, BT_NONE);
return;	
}
dec2=0;
d1=0;
d2=0;
for (j=nbpoint[l]-1;j<nbpoint[l+1]-2;j++)
for (i=0;i<3;i++){
d1+=ABS(mm[j][i]-mm[j+1][i]);
d2+=ABS(mm[j][i+3]-mm[j+1][i+3]);
}
if (d1>d2)
dec2=3;

long int z,zz,err=0,tr,zo,c1[3],ht,hs,x,y;
HANDLE handle ;

while (1){
strcpy(buf,IntToStr(mm[nbpoint[l]-1][vz+2-dec2]));
strcat(buf, IntToStr(mm[nbpoint[l]-1][vz-1+dec2]));
strcat(buf, IntToStr(mm[nbpoint[l]-1][vz-1+dec2]));
 pbuf+=4;
*pbuf='\0';
pbuf+=4;
*pbuf='\0';
pbuf-=8;
if (err) DlgMessage ("ERROR","Wrong Input", BT_OK, BT_NONE);
 handle = DialogNewSimple (140, 80);
DialogAddTitle (handle, "Shape into Cone...", BT_OK, BT_NONE);

DialogAddRequest (handle, 3, 16, "Base Depth", 1, 3, 8);
DialogAddRequest (handle, 3, 27, "Summit Depth",5, 3, 8);
DialogAddRequest (handle, 3, 38, "Section Depth", 9, 3, 8);
DialogAddText (handle, 3, 50, "For a Cone Without Section,");
DialogAddText (handle, 3, 57, "put Summit Depth = Section Depth...");

DialogDo (handle, CENTER, CENTER, buf, NULL);
HeapUnlock (handle);
	HeapFree (handle);	

strncpy(buf2,buf,4);
z=atoi(buf2);
pbuf+=5;
strncpy(buf2,pbuf,4);
zz=atoi(buf2);
pbuf+=4;
strncpy(buf2,pbuf,4);
tr=atoi(buf2);
pbuf-=9;
err=1;

if (!((z<=tr&&tr<=zz)||(zz<=tr&&tr<=z)))
{
	DlgMessage ("ERROR","Section must be between Summit and base...", BT_OK, BT_NONE);
err=0;
continue;
}
if (z>-1&&z<116&&zz>-1&&zz<116&&tr>-1 && tr<116) break;
}



ht=ABS(zz-z);
hs=ABS(tr-zz);

for (i=nbpoint[l];i<nbpoint[l+1];i++)
{
	mm[i-1][vz+2]=z;
	mm[i-1][vz-1]=tr;
}
if (tr==z)
{
	compile();
	return;
}


was_2=modeh[l];
modeh[l]=SGN(modeh[l]);
		if (z!=tr)
	modeh[l]=2;

if (was_2==1&&modeh[l]==2)
		  add_texture(l,nbpoint[l+1]-nbpoint[l],2);

compile();


c1[0]=0;c1[1]=0;c1[2]=0;
for (i=nbpoint[l];i<nbpoint[l+1];i++)
{
c1[0]+=mm[i-1][3-dec2];
c1[1]+=mm[i-1][4-dec2];
c1[2]+=mm[i-1][5-dec2];
}
c1[0]=(4*c1[0])/(nbpoint[l+1]-nbpoint[l]);
c1[1]=(4*c1[1])/(nbpoint[l+1]-nbpoint[l]);
c1[2]=(4*c1[2])/(nbpoint[l+1]-nbpoint[l]);

zo=(100*hs)/ht;
for (i=nbpoint[l];i<nbpoint[l+1];i++)
{
x=4*mm[i-1][vx+2-dec2]-c1[vx-1];
y=4*mm[i-1][vy+2-dec2]-c1[vy-1];
x=x*zo/100;
y=y*zo/100;

mm[i-1][vx+2]=mm[i-1][vx+2-dec2];
mm[i-1][vy+2]=mm[i-1][vy+2-dec2];

mm[i-1][vx-1]=(c1[vx-1]+x)>>2;
mm[i-1][vy-1]=(c1[vy-1]+y)>>2;
}
int temp;

if (zz<z)
{
for (i=nbpoint[l]-1;i<nbpoint[l+1]-1;i++)
for (j=0;j<3;j++)
{
temp=mm[i][j];
mm[i][j]=mm[i][j+3];
mm[i][j+3]=temp;
}	
}	
	

compile();
redes();
}

/*
void save()//int mod)
{   
int mod=0;
int new_code=12390; 
//int version=100;  
int buf2[5];
char old_name[10],old_fold[10],fi[20],folder_n[100][10],
active_fold[10],cur_fold[10];
 
int c=0;
char *pfi=fi;
 
HANDLE handle,hPopup; 
SYM_ENTRY *se;
BYTE HomeFolder[] = {0,127,0};

if (mod)
goto save_file;                    

FolderGetCur (active_fold);

if (obj==0)
return;
buf2[0]=1; 
 
if ((hPopup = PopupNew( NULL, 0 )) == H_NULL)
{
//mem_err();
return;
}
FolderOp( HomeFolder+2,FOP_LOCK );
se = SymFindFirst( HomeFolder+2, 0 );
while (se != NULL) {
//if ((se->Flags & SF_FOLDER) && !IsTempNameChar(se->Name[0])) {
if (strcmp(active_fold,(char *) se->name)==0)
buf2[0]=c+1;
strcpy(folder_n[c],(char *) se->name);
PopupAddText( hPopup, EOF, (char *) se->name, c+1 );
c++; 
se = SymFindNext();
} 
FolderOp( HomeFolder+2, FOP_UNLOCK );


strcpy(old_name,name);
strcpy(old_fold,foldfile);


    if ((handle = DialogNew( 130,60, NoCallBack))== H_NULL )
    {
    //mem_err();
    return;
    }
	// handle = DialogNewSimple (130, 70);
	DialogAddTitle (handle,"SAVE AS A 3DO FILE...", BT_OK, BT_CANCEL);
    DialogAddPulldown (handle,5,20,"Folder :",hPopup,0);
    DialogAddRequest (handle,5,35,"FileName",0,8,11);
  
	if (DialogDo (handle, -1, -1,name,buf2) != KEY_ENTER)
	{       
   strcpy(name,old_name);
   strcpy(foldfile,old_fold);
    HeapFree (handle);
    HeapFree (hPopup);
       return;
    }	 
 HeapFree (handle);
 HeapFree (hPopup);

 strcpy(foldfile,folder_n[ buf2[0]-1 ]);

save_file : 
 
strcpy(fi,foldfile);

pfi+=strlen(foldfile);
*pfi='\\';
*(++pfi)='\0';  
//DlgNotice( "ERROR",fi);
strcat(fi,name);
//DlgNotice( "ERROR",fi);
//archive(0);//unarchive

FILE *fp;
if ((fp = fopen(fi,"wb"))==NULL||CheckReservedName(SYMSTR(name))!=0)
{
fclose(fp);
strcpy(name,old_name);
strcpy(foldfile,old_fold);
DlgMessage( "ERROR", "Can Not Write In This File...",0,0); 
return;
}
fwrite(&new_code,sizeof(new_code),1,fp);
fwrite(&obj,sizeof(short),1,fp);
fwrite(nbpoint,sizeof(*nbpoint),obj+1,fp);
fwrite(modeh,sizeof(*modeh),obj,fp);
fwrite(mm,sizeof(*mm),(nbpoint[obj]-1),fp);
fwrite(color,sizeof(*color),obj,fp);
fwrite(text_name,sizeof(*text_name),faces,fp);
fputc(0,fp);
fputs("3DX",fp);
fputc(0,fp);
fputc(OTH_TAG,fp);
fclose(fp);
}
*/


int compress()
{
int i,j=0,len=0;
for (i=0;i<faces;i++)
{
		if (strcmp(text_name[i].name,"0")==0)
		{
		  j++;
		}
		else 
		{
			//DlgMessage("","Here",0,0);
		  //len++;
		   if (j>0)		 { 
		   len++ ;
		   strcpy(text_name[len-1].name,"0");
		   text_name[len-1].offset=j+1000; }
       
       len++;	
		   strcpy(text_name[len-1].name,text_name[i].name);
		   text_name[len-1].offset=text_name[i].offset;
		
		j=0;
		}
		
}
if (j>0)
{
len++;
text_name[len-1].offset=1000+j;
strcpy(text_name[len-1].name,"0");
}
/*
//test
char buffer[50];
for (i=0;i<len;i++)
{
sprintf(buffer,"%d",text_name[i].offset);
DlgMessage(text_name[i].name,buffer,0,0);
}
*/



//text_name=realloc(text_name, (len)*sizeof(*text_name));
return len;
}

void uncompress(int len)
{
int n=0,i,j=0;
TEXT_SAVE (*tmp)=calloc(len,sizeof(*text_name));
//char buffer[50];
for (i=0;i<len;i++)
{
strcpy(tmp[i].name,text_name[i].name);
tmp[i].offset=text_name[i].offset;
//sprintf(buffer,"Compress %d",tmp[i].offset);
//DlgMessage(tmp[i].name,buffer,0,0);
}

for (i=0;i<len;i++)
{
		if (tmp[i].offset>999)
    {
    //n+=text_name[i].offset-1000;
       for (j=n;j<n+tmp[i].offset-1000;j++)
       {
       strcpy(text_name[j].name,"0");
       text_name[j].offset=0;
        }
        n+=tmp[i].offset-1000;
    }
    else
    {
       strcpy(text_name[n].name,tmp[i].name);
       text_name[n].offset=tmp[i].offset;
       n++;
     }   
        
}
for (i=n;i<faces;i++)
{
  strcpy(text_name[i].name,"0");
  text_name[i].offset=0;

}

/*
for (i=0;i<faces;i++)
{
sprintf(buffer,"Final  %d",text_name[i].offset);
DlgMessage(text_name[i].name,buffer,0,0);
}
*/
free(tmp);


}


void collision_p()
{
//ClrScr();

int center[3],i,k,j,r=100,flag,dist,p;
int side_xyz[3][8]={{-1,1,1,-1,-1,1,1,-1},{1,1,-1,-1,1,1,-1,-1},{-1,-1,-1,-1,1,1,1,1}};
//static int collision[9];
collision[0]=8;

for (i=0;i<3;i++)
center[i]=Lin[points][i];

for (j=0;j<8;j++)
{  
collision[j+1]=0;
 flag=0;
 for (r=100;r>-1;r-=3)
    {
     if (flag)
      break;
    for (p=0;p<points;p++)
      {
        dist=0;
         for (k=0;k<3;k++)
          {  
           if (SGN(Lin[p][k]-center[k])!=side_xyz[k][j])
            {dist=-1;break;}
             
             dist+=(Lin[p][k]-center[k])*(Lin[p][k]-center[k]);
           }
        
        if (dist==-1) continue;
        if (dist>r*r)
         {
         collision[j+1]=p;
         //printf_xy(50,50,"%d",collision[j+1]);
         //ngetchx();
         flag=1;
         break;
         }
                    
       }            

    }
  
  

 }       

}



int bonus()
{
long int bonus,i,j,l=0,center[3];

for (i=0;i<3;i++)
center[i]=Lin[points][i];

for (i=0;i<8;i++)
for (j=0;j<3;j++)
l += (Lin[collision[i]][j]-center[j])*(Lin[collision[i]][j]-center[j]);

//printf_xy(50,30,"%d",( int) l );
l=l>>8;
l=l*3;
l=l>>2;
//ClrScr();
//printf_xy(50,50,"%d",( int) l );

//ngetchx();
return (int)l;

}


void select_canon()
{
compile();
static char curseur[8]={0x70,0xF8,0xD8,0xF8,0x70,0x00,0x00,0x00};
	int i=0,j=0,l,s;

	memcpy( Vscreen,LCD_MEM, 3840);
Sprite8(Lin[Canon[0]][vx-1],16+Lin[Canon[0]][vy-1],5,curseur,LCD_MEM,SPRT_OR); 
Sprite8(Lin[Canon[1]][vx-1],16+Lin[Canon[1]][vy-1],5,curseur,LCD_MEM,SPRT_OR); 
ngetchx();
   memcpy( LCD_MEM,Vscreen, 3840);
	 	FontSetSys(F_4x6);
   
	while(1)
	{
	
Sprite8(Lin[i][vx-1],16+Lin[i][vy-1],5,curseur,LCD_MEM,SPRT_OR); 

    	FontSetSys(F_4x6);
   
	 	printf_xy(119,33,"Point    :%d   ",i);
  	FontSetSys(F_6x8);
  	for (l=0;l<3;l++)
   	printf_xy(138,70+9*l,"%d  ",Lin[i][l]);
   	
 	 	 s=0;
 	 	 while (s==0)
 	 	 s=ngetchx();
 	 	 
 	 	 if (s==344&&i<points) i++;
 	 	 if (s==338&&i>0) i--;

   
	 	 
 	 	 if (s==264) return;
 	 	 if (s==13) 
 	 	   { 
 	 	     if (!j) DlgMessage ("Canon","Now place next Canon...", BT_OK, BT_NONE);
 	 	     Canon[j]=i;j++;if (j==2) return;}
 	 	     memcpy( LCD_MEM,Vscreen, 3840); 	 
 	 	
 	 	}	 
 	
 	
	 
 	
}




//Save your file routine
void save(int mode)
{
char old_name[10],err=0;
int s_bonus;
//SHIP ship;


int height=50,i,j;
if (!mode)
height=65;

strcpy(old_name,name);

int new_code=12399,len,new_code_ship=21251;

HANDLE handle = DialogNewSimple (150, height);
DialogAddTitle (handle, "Save", BT_OK, BT_CANCEL);
DialogAddRequest(handle, 3, 23, "Name`", 0, 8, 14);
if (!mode)
DialogAddText (handle, 3, 39, "As a Ship for Sp. Dementia.");

if (DialogDo (handle, CENTER, CENTER,name, NULL) == KEY_ESC)
{
	HeapUnlock (handle);
	HeapFree (handle);
strcpy(name,old_name);
return;
}
	HeapUnlock (handle);
	HeapFree (handle);

if ((name[0]>47&&name[0]<58)|| strncmp("sw89",name,5)==0||
CheckReservedName(SYMSTR(name))!=0)
err=1;


if (ARCH)
archive(0);

len=compress();


FILE *fp;
if ((fp = fopen(name,"wb"))==NULL||err)
{
fclose(fp);
strcpy(name,old_name);
DlgMessage("ERROR","Can't write in this file...",0,0);
uncompress(len);
return;
}

if (mode)
{

fwrite(&new_code,sizeof(new_code),1,fp);
fwrite(&obj,sizeof(short),1,fp);
fwrite(nbpoint,sizeof(*nbpoint),obj+1,fp);
fwrite(modeh,sizeof(*modeh),obj,fp);
fwrite(mm,sizeof(*mm),(nbpoint[obj]-1),fp);
fwrite(color,sizeof(*color),obj,fp);
fwrite(&len,sizeof(len),1,fp);
fwrite(text_name,sizeof(*text_name),len,fp);

fputc(0,fp);
fputs("3DX",fp);
fputc(0,fp);
fputc(OTH_TAG,fp);
}
else
{
compile();
collision_p();
s_bonus=bonus();

for (i=0;i<points;i++)
  for (j=0;j<3;j++)
  {
   Lin[i][j]-=Lin[points][j];
   Lin[i][j]*=5;
   Lin[i][j]=Lin[i][j]>>3;
   }
for (i=0;i<ligne;i++)
  {
   Ligne[i][0]--;
   Ligne[i][1]--;
  }

fwrite(&new_code_ship,sizeof(new_code),1,fp);
fwrite(&points,sizeof(points),1,fp);
fwrite(&ligne,sizeof(ligne),1,fp);
fwrite(Lin,sizeof(*Lin),points,fp);
fwrite(Ligne,sizeof(*Ligne),ligne,fp);
fwrite(collision,sizeof(short),9,fp);
fwrite(Canon,sizeof(short),2,fp);
fwrite(&s_bonus,sizeof(short),1,fp);

fputc(0,fp);
fputs("SHIP",fp);
fputc(0,fp);
fputc(OTH_TAG,fp);
}

fclose(fp);
//free(modeh2);
uncompress(len);

}






void calc_face()
{
int i;
faces=0;
for (i=0;i<obj;i++)
faces+=(nbpoint[i+1]-nbpoint[i])*(ABS(modeh[i])-1)+2;
}



/*
int open()//int mod )
{    
short size,mod=0,i;
int new_code=12390,code,c,code_3dx=12345; 
//int version=100,ver;
int buf2[5];
char old_name[8],buf[5],old_fold[10]; 
char folder_n[100][10],files[150][10],fi[20],fi2[20],fi3[25];
char fold_sel[10],cur_fold[10],type[10],active_fold[10];
char *pfi=fi;
FILE *fp;            

//archive

//HANDLE hPopup;
HANDLE handle,hPopup;
SYM_ENTRY *se;
BYTE HomeFolder[] = {0,127,0};
strcpy(old_fold,foldfile); 

if (mod)
goto open_file; 

//get_fold(folder_n);

// start:

c=0;
strcpy(old_name,name);
FolderGetCur ((BYTE *)active_fold);

if ((hPopup = PopupNew( NULL, 0 )) == H_NULL)
return 1;
FolderOp( HomeFolder+2, FOP_LOCK );
se = SymFindFirst( HomeFolder+2, 0 );
while (se != NULL) {
//if ((se->Flags & SF_FOLDER) && !IsTempNameChar(se->Name[0])) {
strcpy(folder_n[c],(char *) se->name);
if (strcmp(active_fold,(char *) se->name)==0)
buf2[0]=c+1;
PopupAddText( hPopup, EOF, (char *) se->name, c+1 );
c++; 
se = SymFindNext();
} 
 


FolderOp( HomeFolder+2, FOP_UNLOCK );



//PopupDo( hPopup, -1,-1, 0 );
//PopupFree( hPopup );
//return; 

// buf2[0]=1; 

 

if ((handle = DialogNew( 130,60, NoCallBack))==H_NULL)
{
//mem_err();
return 1;
}
	// handle = DialogNewSimple (130, 70);
	DialogAddTitle(handle,"OPEN A 3DX FILE...", BT_OK, BT_CANCEL);
	DialogAddText(handle,15,18,"Select the Folder to Browse...");
    DialogAddPulldown(handle,15,30,"Folder :",hPopup,0);
	if (DialogDo (handle, -1, -1,NULL,buf2) != KEY_ENTER)
	{       
    HeapFree (handle);
    HeapFree (hPopup);
       return 1;
    }	 
 HeapFree (handle);
 HeapFree (hPopup);
//return;

fold_sel[0]='\0';
strcpy(cur_fold,folder_n[ buf2[0]-1 ]);

//DlgNotice( "ERROR", cur_fold); 

//if (oldTop = TokenizeSymName( (BYTE *)cur_fold ,0))
//top_estack = oldTop;

c=0;
if ((hPopup = PopupNew( NULL, 0 )) == H_NULL)
{
//mem_err();
return 1;
}
FolderOp(strcpy(fold_sel+1,cur_fold)+ strlen (cur_fold) , FOP_LOCK );
se = SymFindFirst(strcpy(fold_sel+1,cur_fold)+ strlen (cur_fold), 1 );
strcpy(fi,cur_fold);
//DlgNotice( "ERROR 1",fi);
pfi+=strlen(cur_fold);
*pfi='\\';  
*(++pfi)='\0';  
pfi-=strlen(cur_fold)+1;
//DlgNotice( "ERROR 1",fi);

while (se != NULL) {   

strcpy(fi2,fi);  

strcat(fi2,(char *)se->name);

if ((fp=fopen (fi2,"rb"))!=NULL){
	
	fread(&code,sizeof(code),1,fp);
	if (code==code_3dx||code==new_code)
		  {
	     	//if ((se->Flags & SF_FOLDER) && !IsTempNameChar(se->Name[0])) {
		    strcpy(files[c],(char *)se->name);
	    	PopupAddText( hPopup, EOF, (char *) se->name, c+1 );
	    	c++;
		   }

 fclose( fp );		
     }   
 
  se = SymFindNext();

}    
 

FolderOp(strcpy(fold_sel+1,cur_fold)+ strlen (cur_fold), FOP_UNLOCK );

 if (c==0)
 {
 DlgMessage( "ERROR","No 3DO Files in this Folder...",0,0);
 //goto start;
 return 1;
 }

buf2[0]=1; 

if ((handle = DialogNew( 130,60, NoCallBack))==H_NULL)
{
//mem_err();
return 1;
}
	// handle = DialogNewSimple (130, 70);
	DialogAddTitle (handle,"OPEN A 3DO FILE...", BT_OK, BT_CANCEL);
	DialogAddText (handle,15,18,"Now Select your File...");
	DialogAddPulldown(handle,15,30,"File :",hPopup,0);
	if (DialogDo (handle, -1, -1,NULL,buf2) != KEY_ENTER)
	{       
    HeapFree (handle);
    HeapFree (hPopup);
    // goto start;
    return 1;
    }	 
 HeapFree (handle);
 HeapFree (hPopup);


strcpy(name,files[buf2[0]-1]);

//if (KB_ENTER != Dialog( &tDialog3, -1, -1, name, NULL ))
// {
	//strcpy(name,old_name);
	// return ;
 //}         
 
//pfi=pfirst;
//DlgNotice( "F",cur_fold);
//DlgNotice( "N",name);

strcpy(fi,cur_fold);
pfi+=strlen(cur_fold);
*pfi='\\';   
*(++pfi)='\0'; 
//DlgNotice( "Fi",fi);
strcat(fi,name);
strcpy(foldfile,cur_fold);
//DlgNotice( "ERROR",fi);

open_file :
  
if (mod)
{  
strcpy(fi,foldfile);
pfi+=strlen(foldfile);
*pfi='\\';  
*(++pfi)='\0'; 
strcat(fi,name);
}     


fi3[0]='\0';
se=DerefSym(SymFind(strcpy(fi3+1,fi)+ strlen (fi)));
size=HeapSize(se->handle);
sprintf(type,"%d",size);
//DlgNotice("Size",type);
if (HeapAvail()<size*8)
{  
strcpy(name,old_name);
strcpy(foldfile,old_fold);
if (!mod)
DlgMessage("ERROR","Not Enought Memory To Open This File",0,0);
return 1;
}
 
 
if((fp=fopen (fi,"rb"))==NULL)
{
DlgMessage( "ERROR", "Can Not Open This File...",0,0); 
strcpy(name,old_name);
strcpy(foldfile,old_fold);
return 1;
}

fread(&code,sizeof(code),1,fp);
//FRead (&version,sizeof(version), &f);


	fread(&obj,sizeof(obj),1,fp);
	nbpoint = realloc (nbpoint,(obj+1)*sizeof (*nbpoint)); 
	modeh = realloc (modeh,obj*sizeof (*modeh));  
	color=realloc(color,obj*sizeof(*color));
			
DrawStr(50,50,"Reading1...",A_REPLACE);
			
	fread(nbpoint,sizeof(*nbpoint),obj+1,fp);
					
	mm= realloc(mm, (nbpoint[obj]-1)*sizeof(*mm));
DrawStr(50,50,"Reading2...",A_REPLACE);

  fread(modeh,sizeof(*modeh),obj,fp);
DrawStr(50,50,"Reading3...",A_REPLACE);

	fread(mm,sizeof(*mm),(nbpoint[obj]-1),fp);
DrawStr(50,50,"Reading4...",A_REPLACE);
	
  fread(color,sizeof(*color),obj,fp);
					
DrawStr(50,50,"OK",A_NORMAL);
	//ngetchx();
	//calc_face();
	faces=0;
  for (i=0;i<obj;i++)
  faces+=(nbpoint[i+1]-nbpoint[i])*(ABS(modeh[i])-1)+2;
				
	text_name=realloc(text_name, (faces)*sizeof(*text_name));
					
	if (code==new_code)
	 {
		 DrawStr(50,50,"Reading5...",A_REPLACE);
				fread(text_name,sizeof(*text_name),faces,fp);
					
		 }
    else 
	       {
	          DrawStr(50,50,"Reading6...",A_REPLACE);

  	      for (i=0;i<faces;i++)
          strcpy(text_name[i],"0");
        DrawStr(50,50,"Reading7...",A_REPLACE);
          
         }
          	fclose(fp);
					pile=nbpoint[obj];
				 DrawStr(50,50,"Reading8...",A_REPLACE);
				//DrawStr(50,60,"OK",A_NORMAL);
			
					//ngetchx();
	//	}	

		
 DrawStr(50,50,"Reading9...",A_REPLACE);
return 0;
} 
     

*/


//Open a file routine
void open(void)
{
int code_3dx=12345,new_code=12390,latest_code=12399,
i,no_load;
char old_name[10];
strcpy(old_name,name);
FILE *fp1;
int len;
//TIOSname1[0]=0;
//TIOSname2[0]=0;



//fp1 = fopen(name,"rb"); 
//if (fp1!=NULL) 
//{
//fclose(fp1);
//EM_moveSymToExtMem(strcpy (TIOSname1 + 1, name) + strlen (name), HS_NULL); 
//}

//archive(1);//archive



//Archive the current file
//  TRY
 // EM_moveSymToExtMem (strcpy (TIOSname1 + 1, name) + strlen (name),HS_NULL); 
 //ER_success ();
 // ONERR
 // ENDTRY


no_load=0;
//wrong_code=0;

HANDLE handle = DialogNewSimple (140, 55);
DialogAddTitle (handle, "OPEN .3DX FILE", BT_OK, BT_CANCEL);
DialogAddRequest (handle, 3, 30, "Name`", 0, 8, 14);
if (DialogDo (handle, CENTER, CENTER,name, NULL) == KEY_ESC)
{
no_load=1;
}

HeapUnlock (handle);
HeapFree (handle);

if (no_load)
{
strcpy(name,old_name);
return; 
}

//SYM_ENTRY *SymPtr = DerefSym (
//SymFind (strcpy (TIOSname2 + 1, name) + strlen (name)) );

//if (!SymPtr) 
//{
//DlgMessage ("ERROR","Do not Exist...", BT_OK, BT_NONE);
//return;
//}


//strcpy (TIOSname1 + 1, old_name) + strlen (old_name),HS_NULL

fp1 = fopen(name,"rb"); 
if (fp1==NULL) 
{
DlgMessage ("ERROR","Do not Exist...", BT_OK, BT_NONE);
strcpy(name,old_name);
return;
}
 
 

//while(1){
//TRY
	
			fread(&code,sizeof(code),1,fp1);
			if (code!=code_3dx&&code!=new_code&&code!=latest_code)
			{
				fclose(fp1);
			 // ER_success ();
			 DlgMessage ("ERROR","This is not a .3DX File...", BT_OK, BT_NONE);
			// wrong_code=1;
			 strcpy(name,old_name);
			 return;
			}
			
	//		if (!wrong_code)
		//	{
					fread(&obj,sizeof(obj),1,fp1);
					nbpoint = realloc (nbpoint,(obj+1)*sizeof (*nbpoint)); 
					modeh = realloc (modeh,obj*sizeof (*modeh));  
					color=realloc(color,obj*sizeof(*color));
					
			
			
					fread(nbpoint,sizeof(*nbpoint),obj+1,fp1);
					
					mm= realloc(mm, (nbpoint[obj]-1)*sizeof(*mm));
				//	DrawStr(50,50,"Reading2...",A_REPLACE);

					fread(modeh,sizeof(*modeh),obj,fp1);
				//	DrawStr(50,50,"Reading3...",A_REPLACE);

					fread(mm,sizeof(*mm),(nbpoint[obj]-1),fp1);
          //DrawStr(50,50,"Reading4...",A_REPLACE);
	
					fread(color,sizeof(*color),obj,fp1);
					
					//DrawStr(50,50,"OK",A_NORMAL);
					//ngetchx();
					//calc_face();
					faces=0;
          for (i=0;i<obj;i++)
          faces+=(nbpoint[i+1]-nbpoint[i])*(ABS(modeh[i])-1)+2;
				
					text_name=realloc(text_name, (faces)*sizeof(*text_name));
					
					if (code==latest_code)
					 {
					 //DrawStr(50,50,"Reading5...",A_REPLACE);
           fread(&len,sizeof(len),1,fp1);
         //printf_xy(50,50,"%d",len);
         //ngetchx();
         
           fread(text_name,sizeof(*text_name),len,fp1);
					 fclose(fp1);
					 uncompress(len); 
					 
					 }
	       else 
	       {
	       	fclose(fp1);
	      
	      
	      //  DrawStr(50,50,"Reading6...",A_REPLACE);
  	      for (i=0;i<faces;i++)
          {
          strcpy(text_name[i].name,"0");
          text_name[i].offset=0;
          }         
       //  DrawStr(50,50,"Reading7...",A_REPLACE);
          
         }
					 
				
				pile=nbpoint[obj];
				 //DrawStr(50,50,"Reading8...",A_REPLACE);
					//DrawStr(50,60,"OK",A_NORMAL);
			
					//ngetchx();
	//	}	

		
// DrawStr(50,50,"Reading9...",A_REPLACE);
  //  ER_success ();
 //        return;
//ONERR
//DlgMessage ("ERROR","Incorrect FileName", BT_OK, BT_NONE);

//ENDTRY


//}

					
}


// Change the view in the Editor
void changevue(int x,int y,int z)
{
	vx=x;
	vy=y;
	vz=z;
	if (obj==0) return;
	
	compile();
	redes();
		}

//Delete your object in all the data arrays
void delete(void)
{
	if (obj==0) return;
	int l=choix(),i,j,pi=pile,offset=0,dec=0,dif=0;
	if (l==264) return;
	pile-=nbpoint[l+1]-nbpoint[l];
	dif=nbpoint[l+1]-nbpoint[l];
 dec=dif*(ABS(modeh[l])-1)+2;
	
		if (l!=obj-1&&obj!=1)
	{
	for (i=nbpoint[l+1]-1;i<pi-1;i++)
		for (j=0;j<6;j++)
	mm[i-dif][j]=mm[i][j];
						

for (i=0;i<l;i++)
offset+=(nbpoint[i+1]-nbpoint[i])*(ABS(modeh[i])-1)+2;

for (i=offset;i<faces-dec;i++)
{
strcpy(text_name[i].name,text_name[i+dec].name);
text_name[i].offset=text_name[i+dec].offset;
}

	for (i=l+1;i<obj;i++)
		{
		nbpoint[i]=nbpoint[i+1]-dif;
		modeh[i-1]=modeh[i];
		color[i-1]=color[i];	
				}

}

faces-=dec;
obj--;
		
text_name=realloc(text_name, (faces)*sizeof(*text_name));	

		//add_texture(l+1,
		
	mm= realloc(mm,(pile-1)*sizeof(*mm));
	modeh= realloc(modeh,(obj)*sizeof(*modeh));
	color= realloc(color,(obj)*sizeof(*color));
	nbpoint= realloc(nbpoint,(obj+1)*sizeof(*nbpoint));

	compile();
	redes();
}



/*
void property()
{
run=0;
work_time+=mseconds50;
long int hour,min,sec;
	WINDOW w1;
  WinOpen(&w1,&(WIN_RECT){20,20,140,80},WF_SAVE_SCR|WF_ROUNDEDBORDER,"Property");
  WinBackground(&w1,A_REVERSE);
  WinAttr(&w1,A_NORMAL);
  WinFont(&w1,F_4x6);
  WinActivate(&w1);
  WinClr(&w1);
 
  //FontSetSys (F_6x8); 
WinStrXY (&w1,10,5,"FileName :");
WinStrXY (&w1,70,5,name);
WinStrXY (&w1,10,14,"Lines :");
char *buf =NULL;
buf=IntToStr(ligne);
WinStrXY (&w1,70,14,buf);
WinStrXY (&w1,10,23,"Points :");
buf=IntToStr(points);
WinStrXY (&w1,70,23,buf);
WinStrXY (&w1,10,32,"Polygons :");
buf=IntToStr(faces);
WinStrXY (&w1,70,32,buf);
WinStrXY (&w1,10,41,"Triangles :");
buf=IntToStr(triangle);
WinStrXY (&w1,70,41,buf);

hour=mseconds50%(3600*19);
min=(mseconds50-hour)%(60*19);
sec=(mseconds50-3600*19*hour-60*19*min)/19;
WinStrXY (&w1,10,50,"Time :");
//buf=IntToStr(hour);
//WinStrXY (&w1,50,50,buf);
buf=IntToStr(min);
WinStrXY (&w1,50,50,buf);
buf=IntToStr(sec);
WinStrXY (&w1,70,50,buf);

  WinFont(&w1,F_4x6);
	 ngetchx();
  WinClose(&w1);
	reset=1;
	run=1;
}


*/


/*Write infos in the file 'sw89sav'*/

void write()
{


FILE *fp;
int latest_code=12399;
//Open a file  wb => Write in Binary Mode
fp = fopen("ed3dsav","wb");
if (fp==NULL)
return;

//Write the 'Magic Number'   (the one in this source is false)
fwrite(&latest_code,sizeof(latest_code),1,fp);
//Write Options
fwrite(&disto,sizeof(disto),1,fp);
fwrite(&perspective,sizeof(perspective),1,fp);
fwrite(&default_z_buf,sizeof(default_z_buf),1,fp);
fwrite(&center_defined,sizeof(center_defined),1,fp);
fwrite(&center_input,sizeof(center_input),1,fp);
fwrite(&auto_archiv,sizeof(auto_archiv),1,fp);
fwrite(&grille,sizeof(grille),1,fp);
// Put extension
fputc(0,fp);
fputs("OPT",fp);
fputc(0,fp);
fputc(OTH_TAG,fp);
//Close the File
fclose(fp);

//if (AMS_2xx)
//EM_moveSymToExtMem(SYMSTR("ed3dsav"),HS_NULL);


}

int load()
{
int code;
FILE *fp;

EM_moveSymFromExtMem(SYMSTR ("ed3dsav"),HS_NULL);

// Open a File rb => Read in Binary mode
fp = fopen("ed3dsav","rb");
if (fp==NULL) 
return 1;


//Search the 'Magic Number'
fread(&code,sizeof(code),1,fp);
// if it isn't the 'good' Magic Number,don't read the file... 
if (code==12399){
   	//Read Options
fread(&disto,sizeof(disto),1,fp);
fread(&perspective,sizeof(perspective),1,fp);
fread(&default_z_buf,sizeof(default_z_buf),1,fp);
fread(&center_defined,sizeof(center_defined),1,fp);
fread(&center_input,sizeof(center_input),1,fp);
fread(&auto_archiv,sizeof(auto_archiv),1,fp);
fread(&grille,sizeof(grille),1,fp);
}
//Close the File
fclose(fp);
return 0;
}


//Main function
void _main(void)
{
LCD_BUFFER scr;
 LCD_save(scr);

SYM_ENTRY *SymPtr = DerefSym (SymFind (SYMSTR("ed3dsav")));
//if doesn't here,create one...
if (!SymPtr) 
write();
//Else Open the "sw89sav"
else
{
if (load())
write();
}
 
faces=0;
/*int val=OSInitKeyInitDelay (100);
if (val!=99)
return; 
*/
OSInitBetweenKeyDelay (16);

strcpy(name,"NewFile");

if (title())
{
  LCD_restore(scr);
  ST_showHelp("http://membres.lycos.fr/dcoz"); 
return;
}

wait(30);
ngetchx();
GrayOff();
FontSetSys(F_6x8);

while(1)
{
//OSFreeTimer (APD_TIMER);
//OSRegisterTimer (APD_TIMER, 5*20);

 work_time=0;
 reset=1;
  run=1;
  center_input=0;



Vscreen = malloc(3840);
nbpoint = calloc (1, sizeof(*nbpoint));   
text_name = calloc (1, sizeof(*text_name));

color	 = calloc (1, sizeof(*color));   
mptca = calloc (1, sizeof (*mptca)); 

modeh = calloc (1, sizeof (*modeh)); 
mm = calloc (1, sizeof (*mm));  
Lin = calloc (1, sizeof (*Lin));  
Ligne = calloc (1, sizeof (*Ligne));  
if (ARCH)
archive(1);
//archive(1);//archive
/*
char TIOSname[10];
TIOSname[0]=0;
 TRY
 EM_moveSymToExtMem (strcpy (TIOSname + 1, name) + strlen (name),HS_NULL); 
 ER_success ();
ONERR
ENDTRY
*/
strcpy(name,"NewFile");

Canon[0]=0;
Canon[1]=1;

nbpoint[0]=1;
vue=1;
vx=1,vy=2,vz=3,pile=1,obj=0,points=0,ligne=0,faces=0,triangle=0;
ClrScr();
int result,i,j,quit=0,x=0,y=0,yy,xx,e,d;



if (grille)
{
	for (i=2;i<118;i+=5)
 for (j=18;j<94;j+=5)
 DrawPix (i, j,A_NORMAL); 

DrawLine(1,17,118,17,A_NORMAL);
DrawLine(1,17,1,94,A_NORMAL);
DrawLine(1,94,118,94,A_NORMAL);
DrawLine(118,94,118,17,A_NORMAL);
 }
 
 memcpy(Vscreen,LCD_MEM, 3840);

HANDLE handle;

while(quit==0)
{

//run=0;
work_time+=mseconds50;
 reset=1;
  run=1;
 
  
memcpy(LCD_MEM, Vscreen, 3840);
DrawStr(122,70,"X:",A_NORMAL);
DrawStr(122,79,"Y:",A_NORMAL);
DrawStr(122,88,"Z:",A_NORMAL);
DrawStr(119,17,"       ",A_REPLACE);
DrawStr(119,17,name,A_REVERSE);
FontSetSys(F_4x6);
printf_xy(119,26,"Line     :%d  ",ligne);
printf_xy(119,33,"Point    :%d  ",points);
printf_xy(119,40,"Object :%d  ",obj);
printf_xy(119,47,"Polyg.  :%d  ",faces);
printf_xy(119,54,"Trian.   :%d  ",triangle);
FontSetSys(F_6x8);
//printf_xy(50,51,"Tim:%d  ",work_time);

DrawStr(119,61,(vue==1 ? "Front  ":(vue==2 ? "Top":"Side")),A_NORMAL);




handle = MenuNew (2, 240, 18);


MenuAddIcon (handle, 0, &icon1, 10, 0);

MenuAddIcon (handle, 0, &icon2, 20, 0);

MenuAddIcon (handle, 0, &icon3, 30, 0);

MenuAddIcon (handle, 0, &icon4, 50, 0);

MenuAddIcon (handle, 0, &icon5, 60, 0);
MenuAddText (handle, 10, " New ", 11, 0);
MenuAddText (handle, 10, " Open ", 12, 0);
MenuAddText (handle, 10, " Save ", 13, 0);
MenuAddText (handle, 10, " Options...", 14, 0);
MenuAddText (handle, 10, " Export as Ship", 15, 0);
MenuAddText (handle, 10, " About", 16, 0);

//MenuAddText (handle, 10, " Archive", 15, 0);
//MenuAddText (handle, 10, " Unarchive", 16, 0);
MenuAddText (handle, 10, " Quit ", 17, 0);

MenuAddText (handle, 20, "Rectangle", 21, 0);
MenuAddText (handle, 20, "Ellipse", 22, 0);
MenuAddText (handle, 20, "Line", 23, 0);
MenuAddText (handle, 20, "Shape into Cone", 24, 0);
MenuAddText (handle, 20, "White Color", 26, 0);
MenuAddText (handle, 20, "Black Color", 25, 0);
MenuAddText (handle, 20, "With Border", 27, 0);
MenuAddText (handle, 20, "Without Border", 28, 0);


MenuAddText (handle, 30, "Depth", 31, 0);
MenuAddText (handle, 30, "Modify Coord", 39, 0);
MenuAddText (handle, 30, "Modify Center", 30, 0);
MenuAddText (handle, 30, "Delete", 34, 0);
MenuAddText (handle, 30, "Select Canons", 98, 0);
MenuAddText (handle, 30, "Translate ALL", 33, 0);
MenuAddText (handle, 30, "Translate", 32, 0);
MenuAddText (handle, 30, "Zoom ALL", 36, 0);
MenuAddText (handle, 30, "Zoom", 35, 0);
MenuAddText (handle, 30, "Rotate", 37, 0);
MenuAddText (handle, 30, "Rotate ALL", 38, 0);



MenuAddText (handle, 50, "Front", 51, 0);
MenuAddText (handle, 50, "Top", 52, 0);
MenuAddText (handle, 50, "Side", 53, 0);

MenuAddText (handle, 60, "Wire Frame", 61, 0);
//MenuAddText (handle, 60, "Fast", 62, 0);
MenuAddText (handle, 60, "First Person", 63, 0);
MenuAddText (handle, 60, "Solid & no BFC", 64, 0);
MenuAddText (handle, 60, "Solid & BFC", 65, 0);


HANDLE exec_handle = MenuBegin (HLock (handle), 0, 0, 0);

result = -2;

while (result == -2)
   {
   	
   	result = MenuKey (exec_handle, ngetchx());
    }
      
  if (result!=17){
  	HeapUnlock (handle);
				HeapFree (handle);
				 	HeapFree (exec_handle);
  
  }   
switch (result)
  {
  	
  	case 11:
  
  	free(nbpoint) ;
	  free(modeh);
	 		free(mm);
	
			free(Ligne);
	
			free(Lin);
	
			free(mptca);
	
			free(Vscreen);
	
			free(color);
	
	

	
  	quit=1;
  	break;
  	
  	  case 17:
    if (ARCH)
    archive(1);
   //archive(1);//archive
/*   
   TIOSname[0]=0;

   TRY
   EM_moveSymToExtMem (strcpy (TIOSname + 1, name) + strlen (name),HS_NULL); 
   ER_success ();
   ONERR
   ENDTRY
 */
  	    memcpy( Vscreen,LCD_MEM, 3840);
  	  memcpy(LCD_MEM, Vscreen, 3840);
  	  PortRestore();
    		MenuEnd (exec_handle);
				HeapUnlock (handle);
				HeapFree (handle);
				
				MenuUpdate ();
			
		free(nbpoint) ;
	
	  free(modeh);
	
			free(mm);
	
			free(text_name);
	
			free(Ligne);
			free(Lin);
			free(mptca);
			free(Vscreen);
			free(color);
	write();

	 LCD_restore(scr);
  ST_showHelp("http://membres.lycos.fr/dcoz"); 
				return;
				break;
			
			
				
	  case 98:
	   if (obj==0)
			break;
			select_canon();
			break;
		
	
			
			
			
			
				case 12:
				
			 //archive(1);
    if (ARCH)
     archive(1);
			open();
			compile();
			redes();
			break;
			/*
		  case 15:
		  if (obj==0) break;
			archive(3);
			break;
		  	*/
		  		
		 
			
			case 13:
			
			if (obj==0) break;
			//archive(0);
			save(1);
			break;
			
			case 15:
			if (obj==0) break;
			//archive(0);
			save(0);
			break;
			
			case 16:
			
			handle = DialogNewSimple (130, 76);
      DialogAddTitle (handle, "About...", BT_OK, BT_CANCEL);

      DialogAddText (handle,13,16,"Edit 3D v 0.96" );
      DialogAddText (handle,13,25,"programmed by David Coz" );
      DialogAddText (handle,13,34,"e-mail : coz.hubert@infonie.fr" );
      DialogAddText (handle,13,43,"For news , visit my website : " );
      DialogAddText (handle,13,52,"http://membres.lycos.fr/dcoz" );
      
DialogDo (handle, CENTER, CENTER,NULL, NULL);
	    HeapUnlock (handle);
	    HeapFree (handle);
			
			break;
			
			
			case 14:
			
			options();
			compile();
			redes();
			break;
		
			case 21:

			 if (curseur(&x,&y,&e,&d)==1) break; 
			xx=x;
			yy=y;
			rect(yy,xx,e,d);
			compile();
			break;
			
			case 22:
		
			 if (curseur(&x,&y,&e,&d)==1) break; 
			xx=x;
			yy=y;
			ell(yy,xx,e,d);
			compile();
			break;
			
				case 23:
		
			 if (curseur(&x,&y,&e,&d)==1) break; 
			xx=x;
			yy=y;
			lign(yy,xx,e,d,1);
			compile();
			break;			
			
			/*	case 24:
				HeapUnlock (handle);
				HeapFree (handle);
				 	HeapFree (exec_handle);

			 if (curseur(&x,&y,&e,&d)==1) break; 
			xx=x;
			yy=y;
			lign(yy,xx,e,d,-1);
			if (obj==0) break;
			compile();
			break;			
			*/
			case 61:
		
//work_time+=mseconds50;
			if (obj==0) break;
			compile();
			trace2(1);
	//		 reset=1;
  //run=1;
						break;
			
			case 64:
		//work_time+=mseconds50;
			if (obj==0) break;
			compile();
			des(0);
						break;
			
			case 65:
		   //   work_time+=mseconds50;
			if (obj==0) break;
			compile();
			des(1);
						break;
			
	/*		
			case 62:
			HeapUnlock (handle);
				HeapFree (handle);
				 	HeapFree (exec_handle);
//work_time+=mseconds50;
			if (obj==0) break;
			compile();
			trace();
			break;
			
		*/	
			case 63:
		
//work_time+=mseconds50;
			if (obj==0) break;
			compile();
			trace2(2);
			break;
			
			
			case 24:
		
			
			if (obj==0)
			break;
			cone();
			break;
			
			
			case 31:
			
			if (obj==0)
			break;
			profondeur();
			break;
	
		case 39:
			
			if (obj==0)
			break;
			mod_coord();
			break;
	
	case 30:
			
			if (obj==0)
			break;
			mod_center();
			break;
	
	
	
		case 52:
			vue=2;
		changevue(1,3,2);
			break;
				   
		case 51:
			changevue(1,2,3);
			vue=1;
			break;		   
	
	
	case 53:
				vue=3;
			changevue(3,2,1);
			break;
	
	case 54:
		compile();
		flip();
		break;
	
	
	
	case 32:
			translater(1);
			break;
	
	case 33:
		translater(2);
			break;
	
	case 34:
			delete();
			break;
	
	case 35:
			zoom(1);
			break;

	case 36:
			zoom(2);
			break;
	
	case 37:
		rotate(1);
			break;

	case 38:
		rotate(2);
			break;
	
	case 25:
		colo(1);
			break;
	
	case 26:
			colo(0);
			break;
	
	case 27:
			bord(0);
			break;
	
	case 28:
			bord(2);
			break;
	
	
	}



}



}


  
}




